/***********************************************************************
 * Bdbj 1.2 (by Jon Cook May 2002)
 *
 * BdbjClientSocket.java 
 * 
 * Create and handle the client socket which receives data from the UI. 
 ***********************************************************************/

package jjc.bdbj.client;

import java.io.*;
import java.net.*;

public class ClientSocket {
    private Socket socket = null;
    private BufferedReader reader = null;
    private PrintWriter writer = null;
    private boolean prompt = false;

    public ClientSocket( int port, String host ) {
        try {
            socket = new Socket( host, port );
            InputStream is = socket.getInputStream( );
            OutputStream os = socket.getOutputStream( );
            reader = new BufferedReader( new InputStreamReader( is ) );
            writer = new PrintWriter( new OutputStreamWriter( os ) );
        } catch( Exception exception ) {
            error( exception );
        }
    }

    public void setPrompt( boolean prompt ) {
	this.prompt = prompt;
    }

    public String readLine( ) {
	String string = "";
	try {
	    string = reader.readLine( );
	} catch( Exception exception ) {
	    error( exception );
	}
	return string;
    }

    public synchronized void writeLine( String reply ) {
	if( prompt ) {
	    System.out.println( reply );
	    return;
	}
        try {
            writer.println( reply );
            writer.flush( );
        } catch( Exception exception ) {
            error( exception );
        }
    }

    public synchronized void error( Exception exception ) {
	System.out.println( exception );
        close( );
        System.exit( 2 );
    }

    public synchronized void close( ) {
        try {
            socket.close( );
        } catch( Exception _ ) { }
    }
}

