/***********************************************************************
 * Bdbj 1.2 (by Jon Cook May 2002)
 *
 * SharedBuffer.java 
 * 
 * A simple shared buffer holding one object.
 ***********************************************************************/

package jjc.bdbj.client;

public class SharedBuffer {
    Object value;
    boolean valid = false;

    public synchronized Object get( ) {
	while( !valid ) {  
	    try {
		wait( );
	    } catch( InterruptedException ignored ) {
	    }
	}
	valid = false;
	notifyAll( );
	return value;
    }

    public synchronized void put( Object object ) {
	while( valid ) {
	    try {
		wait( );
	    } catch( InterruptedException ignored ) {
	    }
	}
	value = object;
	valid = true;
	notifyAll( );
    }
}
