/***********************************************************************
 * Bdbj 1.2 (by Jon Cook May 2002)
 *
 * SharedFIFOQueue.java 
 * 
 * A shared first-in-first-out queue.
 * Used in Bdbj for passing commands from the client to Kaffe. 
 ***********************************************************************/

package jjc.bdbj.client;

import java.util.Vector;

public class SharedFIFOQueue {
    private Queue queue = new Queue( );

    public synchronized Object get( ) {
	while( queue.isEmpty( ) ) {
	    try {
		wait( );
	    } catch( InterruptedException _ ) { }
	}
	Object ret = queue.get( );
	notifyAll( );
	return ret;
    }

    public synchronized void put( Object object ) {
	queue.addElement( object );
	notifyAll( );
    }

    public synchronized void removeAll( ) {
	queue.removeAllElements( );
	notifyAll( );
    }
}

class Queue extends Vector {
    public Object get( ) {
	Object next = firstElement( );
	removeElementAt( 0 );
	return next;
    }
}
