/***********************************************************************
 * Bdbj 1.2 (by Jon Cook May 2002)
 *
 * Help.java 
 * 
 * Implements the functionality of the help menu.
 ***********************************************************************/

package jjc.bdbj.interfaces.gui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;

public class Help implements ActionListener {

    private DocumentationWindow documentationWindow = null;

    public Help( JFrame parent ) {
	documentationWindow = new DocumentationWindow( parent );
    }

    public MenuData getMenu( ) {
        boolean[] bothModes = { true, true, true };
        MenuItemData[] helpMenuData =
            { new MenuItemData( "Brief Documentation...", "Brief Documentation", this, "alt shift H", bothModes ),
	      new MenuItemData( "About Bdbj...", "About Bdbj", this, "alt H", bothModes ) };
        return new MenuData( "Help", helpMenuData );
    }

    public void actionPerformed( ActionEvent event ) {
	if( event.getActionCommand( ).equals( "About Bdbj" ) )
	    JOptionPane.showMessageDialog( null, "Bdbj 1.2 (2002) Jon Cook", "About", 
					   JOptionPane.INFORMATION_MESSAGE );
	else
	    documentationWindow.showAgain( );
    }
}

class DocumentationWindow extends JFrame implements ActionListener, WindowListener {
    private JEditorPane textArea = null;
    private boolean success = true;
    private JFrame parent = null;
    
    public DocumentationWindow( JFrame parent ) {
        super( "Documentation" );
	
	try {
	    textArea = new JEditorPane( Help.class.getResource( "bdbj.html" ) );
	} catch( Exception failed ) {
	    success = false;
	    return;
	}
	
	this.parent = parent;
        setSize( 960, 640 );
        getContentPane( ).setLayout( new BorderLayout( ) );
        getContentPane( ).add( "Center", new JScrollPane( textArea ) );
        
        JButton button = new JButton( "Dismiss" );
        getContentPane( ).add( "South", button );
        button.addActionListener( this );
	addWindowListener( this );
	textArea.setEditable( false );
    }

    public void windowClosing( WindowEvent event ) {
        actionPerformed( null );
    }

    public void windowIconified( WindowEvent event ) { }
    public void windowOpened( WindowEvent event ) { }
    public void windowDeiconified( WindowEvent event ) { }
    public void windowDeactivated( WindowEvent event ) { }
    public void windowClosed( WindowEvent event ) { }
    public void windowActivated( WindowEvent event ) { }

    public void showAgain( ) {
	if( success ) {
	    show( );
	    setBounds( parent.getBounds( ) );
	    validate( );
	}
	else
	    DefaultDialog.error( "Failed to find documentation file" );
    }

    public void actionPerformed( ActionEvent e ) {
        hide( );
    }
}
